unit ot1;

{ Ingemar Ragnemalm as converted a C otello to Pascal
  this is my Delphi component version of Otello.

  Note that this component doesn't play just like Ingemar's Otello,
  but I really don't know why !

  Paul TOTH <tothpaul@multimania.com>
  http://www.multimania.com/tothpaul
}

{ Note for US readers,
  you can use MenuItems names to translate the menu.
  you can use TOtello default messages to translate TOtello.OnXXX events.
}

{ The component doesn't draw original border and shadow...TFormPaint draw it.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Otello, Menus, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Otello1: TOtello;
    MainMenu1: TMainMenu;
    Game: TMenuItem;
    Skill: TMenuItem;
    Help: TMenuItem;
    GameHint: TMenuItem;
    GamePass: TMenuItem;
    GameNew: TMenuItem;
    N1: TMenuItem;
    GameExit: TMenuItem;
    SkillBeginner: TMenuItem;
    SkillNovice: TMenuItem;
    SkillExpert: TMenuItem;
    SkillMaster: TMenuItem;
    HelpAbout: TMenuItem;
    Score: TLabel;
    StatusBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SkillMasterClick(Sender: TObject);
    procedure GameExitClick(Sender: TObject);
    procedure GameNewClick(Sender: TObject);
    procedure HelpAboutClick(Sender: TObject);
    procedure GamePassClick(Sender: TObject);
    procedure GameHintClick(Sender: TObject);
    procedure Otello1BadMove(Sender: TObject);
    procedure Otello1Lost(Sender: TObject);
    procedure Otello1Win(Sender: TObject);
    procedure Otello1Play(Sender: TObject);
    procedure Otello1Think(Sender: TObject);
  private
    { Dclarations prives }
    Shadow:integer;
    procedure OnIdle(Sender:TObject; var Done: Boolean);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses ot2;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 Application.OnIdle:=OnIdle;
end;

procedure TForm1.OnIdle(Sender:TObject; var Done: Boolean);
 begin
//  Caption:=Copy(Caption,2,length(Caption))+Caption[1];
  Done:=(Otello1.Thinking=False);
 end;

procedure TForm1.FormResize(Sender: TObject);
var
 t,l,w:integer;
 h:integer;
begin
 w:=ClientWidth;
 h:=ClientHeight-Score.Height-StatusBar.Height;
 if w>h then w:=h;
 Shadow:=w div 30;
 l:=(ClientWidth-w) div 2;
 t:=Score.Height+(h-w) div 2;
 dec(w,4*Shadow);
 inc(t,Shadow);
 inc(l,Shadow);
 w:=w and ($FFFF-7)+1; // adjust size to avoid component border
 Otello1.SetBounds(l,t,w,w);
 Invalidate;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
 x,y,w:integer;
 t,l:integer;
begin
 With Canvas do begin
  Brush.Color:=Otello1.Color;
  t:=Otello1.Top;
  l:=Otello1.Left;
  x:=l+Otello1.Width-1;
  y:=t+Otello1.Height-1;
  w:=Shadow;
  Polygon([Point(x,t),Point(x+w,t+w),Point(x+w,y+w),Point(x,y)]);
  Polygon([Point(l,y),Point(x,y),Point(x+w,y+w),Point(l+w,y+w)]);
  Brush.Color:=clBlack;
  Rectangle(x+w,t+2*w,x+2*w,y+w);
  Rectangle(l+2*w,y+w,x+2*w,y+2*w);
 end;
end;

procedure TForm1.GameHintClick(Sender: TObject);
begin
 Otello1.Cheat;
end;

procedure TForm1.GamePassClick(Sender: TObject);
begin
// let the computer play first
 if Otello1.MoveCount=0 then
  Otello1.Pass
 else
  ShowMessage('You may not pass. Move where the cursor is a cross');
end;

procedure TForm1.GameNewClick(Sender: TObject);
begin
 Score.Hide;
 Otello1.NewGame;
end;

procedure TForm1.GameExitClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.SkillMasterClick(Sender: TObject);
begin
 Case Otello1.Skill of
  skBeginner:SkillBeginner.Checked:=False;
  skNovice  :SkillNovice.Checked:=False;
  skExpert  :SkillExpert.Checked:=False;
  skMaster  :SkillMaster.Checked:=False;
 end;
 Otello1.Skill:=TSkill(TMenuItem(Sender).Tag);
 Case Otello1.Skill of
  skBeginner:SkillBeginner.Checked:=True;
  skNovice  :SkillNovice.Checked:=True;
  skExpert  :SkillExpert.Checked:=True;
  skMaster  :SkillMaster.Checked:=True;
 end;
end;

procedure TForm1.HelpAboutClick(Sender: TObject);
begin
 with TForm2.Create(Application) do begin
  ShowModal;
  Free;
 end;
end;

procedure TForm1.Otello1BadMove(Sender: TObject);
begin
 ShowMessage('Vous ne pouvez jouer que l o la souris est une croix');
end;

procedure TForm1.Otello1Lost(Sender: TObject);
begin
 Score.Caption:='Vous perdez de '+IntToStr(-Otello1.Score)+' points';
 Score.Show;
 StatusBar.SimpleText:='Appuyez sur F2 pour rejouer';
end;

procedure TForm1.Otello1Win(Sender: TObject);
begin
 Score.Caption:='Vous gagnez de '+IntToStr(Otello1.Score)+' points';
 Score.Show;
 StatusBar.SimpleText:='Appuyez sur F2 pour rejouer';
end;

procedure TForm1.Otello1Play(Sender: TObject);
begin
 StatusBar.SimpleText:='A vous de jouer';
end;

procedure TForm1.Otello1Think(Sender: TObject);
begin
 StatusBar.SimpleText:='Laissez moi rflchir...';
end;

end.
